import Vue from 'vue'
import App from './App.vue'
import router from './router'
import Storage from 'vue-ls'
import store from './store/'
import CodeEditor from 'bin-code-editor';

import vueTopology from './plugins/index.js'
import _lodash from 'lodash'

import dictComponents from './components/dict/index.js'
import JeecgComponents from '@/components/jeecg/index'

Vue.prototype._lodash=_lodash

import {
  VueAxios
} from "./utils/request"


import Antd from 'ant-design-vue'
import 'ant-design-vue/dist/antd.less'; 

Vue.use(vueTopology)
Vue.use(Antd)
Vue.use(VueAxios, router)
Vue.use(Storage)
Vue.use(CodeEditor);
Vue.use(dictComponents)
Vue.use(JeecgComponents)

Vue.config.productionTip = false

new Vue({
  el: '#app',
  mounted(){
    store.commit('SET_TOKEN', 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJleHAiOjE2NjE5Mjg4MTQsInVzZXJuYW1lIjoiYWRtaW4ifQ.0eAoGo8dadtcRrW8nrfEbWtH_CnVJ8U0Enb0gAJOMl4')
  },
  render: h => h(App),
  router,
  store,
  data:{
    eventHub: new Vue()
  },
}).$mount('#app')
