import '@antv/x6-vue-shape';
import { Graph, Shape, Addon, FunctionExt } from '@antv/x6';
import pick from 'lodash.pick'

// 拖拽生成图形
export const startDragToGraph = (deviceTypeObj, deviceTemplate, presetParams, graph, e, cb) => {
  const nodeConfig = JSON.parse(deviceTemplate.deviceTemplateConfig)
  const node = graph.createNode(nodeConfig)
  const dnd = new Addon.Dnd({
    target: graph,
    validateNode: (node, options) => {
      let config = pick(deviceTemplate, 'id', 'deviceModelId', 'devicePrimaryTypeCode', 'deviceTemplateCode', 'deviceTemplateName', 'themeCode')
      let floorCode = ''
      let floorTypeCode=presetParams['floorTypeCode']
      if(floorTypeCode.length>1){
        floorCode=floorTypeCode.substr(0,1)+presetParams['floorNum']+floorTypeCode.substr(1)
      }else{
        floorCode=presetParams['floorNum']+floorTypeCode

      }
      
      node['data'] = Object.assign(node.data, config, presetParams)
      node['data']['floorCode'] = floorCode
      if(!deviceTypeObj.deviceTemplateIndex)deviceTypeObj.deviceTemplateIndex=1
      setDeviceAttrs(deviceTypeObj, deviceTemplate, node)
      deviceTypeObj.deviceTemplateIndex++
      cb(deviceTypeObj)
    }
  })
  dnd.start(node, e)
  
  function setDeviceAttrs(deviceTypeObj, deviceTemplate, node) {
    let remarkText = ''
    let dodelString = deviceTemplate.deviceModelString//完整编号
    let typeCode = deviceTemplate.devicePrimaryTypeCode//类型编码
    let num = dodelString.indexOf(typeCode)//类型编码在在编号中的位置
    let standard = dodelString.substr(num + typeCode.length)//获取到规格
    let index = deviceTypeObj.deviceTemplateIndex
    if (!standard) {
      remarkText = typeCode + index + standard + '-' + node['data']['floorCode']
    } else {
      remarkText = typeCode + index + '/' + standard + '-' + node['data']['floorCode']
    }
    node.setAttrs({
      remark: {
        textWrap: {
          text: remarkText,
        }
      }
    })
    return remarkText
  }
}




