
import { getAction } from '@/api/manage'
import {message} from 'ant-design-vue'
const topologyTools = {
  state: {
    floorTypeList:[],
    nodeTemplateList:[],
    edgeTemplate:{},
    allCellTemplate:{},
    topologyTemplateList:[]
  },
  mutations: {
    SET_fLOOR_TYPE_LIST(state,value){
          state.floorTypeList=value
    },
    SET_NODE_TEMPLATE_LIST(state,value){
      state.nodeTemplateList=value
    },
    SET_EDGE_TEMPLATE(state, value) {
      state.edgeTemplate = value
    },
    SET_ALL_DEVICTEMLATE(state, value) {
      state.allCellTemplate = value
    },
    SET_TOPOLOGY_TEMPLATE_LIST(state,value){
      state.topologyTemplateList=value
    },

  },
  actions: {
    getFloorTypeList: ({
      commit
    }) => {
        getAction('/topology/floorType/list')
          .then((res) => {
            if (res.success) {
              commit('SET_fLOOR_TYPE_LIST',res.result.records)
            } else {
              message.warning(res.message)
            }
          })
          .catch((err) => {
            message.error(err.message)
          })
    },

    getAllTemplateByTheme: ({
      commit
    }) => {
      getAction('/topology/topologyDeviceTheme/listAllMapTheme')
      .then((res) => {
        if (res.success) {
         let nodeTemplateList = []
         let  edgeTemplate={}
          let allCellTemplate = {}
          // 使用默认主题下的器件模板
          res.result.default.devicePrimaryTypeList.forEach((ele) => {
            ele.deviceTemplateIndex = 1
            if (ele.devicePrimaryTypeCode === 'CABLE') {
              edgeTemplate=ele
            } else {
              nodeTemplateList.push(ele)
            }
            ele.deviceTemplateList.forEach((every) => {
              allCellTemplate[every.id] = every
            })
          })
          commit('SET_NODE_TEMPLATE_LIST', nodeTemplateList)
          commit('SET_EDGE_TEMPLATE', edgeTemplate)
          commit('SET_ALL_DEVICTEMLATE',allCellTemplate)
        } else {
          message.warning(res.message)
        }
      })
      .catch((err) => {
        message.error(err.message)
      })
    },
    getTopologyTemplatelist: ({
      commit
    }) => {
      getAction('/topology/topologyTemplate/list')
      .then((res) => {
        if (res.success) {
          commit('SET_TOPOLOGY_TEMPLATE_LIST',res.result.records)
        } else {
          message.warning(res.message)
        }
      })
      .catch((err) => {
        message.error(err.message)
      })
    },
  }
}

export default topologyTools