import {
  axios
} from '@/utils/request'

import {
    message
} from 'ant-design-vue'
const tuopu = {
  state: {
    project_id: '',
    project: {},
    bts_id: '',
    fault_id:'',
    deviceId: "",
    stationId: "",
    Loading: true,
    bts: {},
    bts_date_range: '',
    bts_logs: [],
    bts_log: {
      sensor_data: [],
    },
    bts_log_id: 0,
    bts_log_data: {},
    bts_error_data:[],
    data_type: 'sn',
    sensor: {},
    device_id: '',
    device: {},
    draw_manager: {},
    sensors: [],
    devices: [],
    fault_log: '',
    fault_sensors: [],
    menu_active_index: "1"
  },
  mutations: {
    // TODO: 放置我们的状态变更函数
    SET_PROJECT_ID(state, value) {
      state.project_id = value;
    },

    SET_BTS_ID(state, value) {
      state.bts_id = value;
    },

    SET_DEVICE_ID(state, value) {
      state.deviceId = value;
    },

    SET_STATION_ID(state, value) {
      state.stationId = value;
    },

    SET_LOADING(state, type) {
      state.Loading = type;
    },

    SET_BTS_LOG_ID(state, value) {
      state.bts_log_id = value ? parseInt(value) : 0
    },

    SET_PROJECT_DATA_TYPE(state, value) {
      state.data_type = value;
    },

    SET_PROJECT_DEVICE_ID(state, value) {
      state.device_id = value;

      for (let index in state.devices) {
        let _device = state.devices[index]
        if (_device['DeviceId'] == value) {
          state.device = _device;
          break;
        }
      }
    },
    FLOOR_CHANGE(state, value){
      state.device = value;
    },
    SET_PROJECT_BTS_error_DATA(state, value){
        state.bts_error_data = value
    },

    SET_PROJECT_BTS_LOG_DATA(state, value) {
      state.bts_log_data = value
      state.devices = value.r2000.device;
      state.sensors = value.r2000.sensor_data;
      // 判断是否需要清空选中的sensor 和 device
      if (state.device_id) {
        let selectedDevice = {};
        let selectedDeviceId = null;
        for (let device of state.devices) {
          if (device.DeviceId == state.device_id) {
            selectedDevice = device
            selectedDeviceId = device.DeviceId
            break;
          }
        }
        state.device = selectedDevice;
        state.device_id = selectedDeviceId;
      }
      if (state.sensors) {
        let selectedSensor = {};
        for (let sensor of state.sensors) {
          if (sensor.iSensorId == state.sensor.iSensorId) {
            selectedSensor = sensor
            break;
          }
        }
        state.sensor = selectedSensor;
      }
    },

    SET_FAULT_ID(state, value) {
      state.fault_id = value
    },
    SET_FAULT_SENSORS(state, value) {
      state.fault_sensors = value
    }
  },
  actions: {
    getBts: ({
      commit,
      state
    }) => {
      if (!state.bts_id) {
        if (state.project.bts && state.project.bts.length > 0) {
          Message('请选择一个BTS');
        } else {
          Message('所选站点无BTS');
        }
      }
      data.getBts(state.bts_id, (bts) => commit('SET_BTS', bts))
    },
    getBtsLog: ({
      commit,
      state
    }) => {
      if (!state.bts_log_id) {
        return;
      }
      // 获取某条 Bts 轮询记录详细内容
      data.getBtsLog(state.bts_log_id, (bts_log) => {
        commit('SET_BTS_LOG', bts_log)
      })
    },

    getBtsLogData: ({
      commit,
      state
    }, cb) => {
      // 获取巡检记录对应的 系统图 信息
      axios.post('/deviceMonitor/deviceGateway/drawingLog', {
        deviceId: state.deviceId
      }).then(res => {
        commit('SET_LOADING', false)
        if (res.code == 1) {
          commit('SET_PROJECT_BTS_LOG_DATA', res)
          if (typeof (cb) === 'function') {
            cb(res);
          }
        } else if (res.code == 0) {
          message.warning(res.message)
        } else {
          message.error(res.message)
        }
      }).catch((error) => {
        commit('SET_LOADING', false)
          console.log(error)
        message.error("无法连接拓扑图接口")
      });
    },

    getBtsErrorData: ({
      commit,
      state
    }, cb) => {
      // 获取巡检记录对应的 系统图 异常信息
      axios.post('/deviceMonitor/deviceGateway/alarmByDraw', {
        deviceId: state.deviceId
      }).then(res => {
        commit('SET_LOADING', false)
        if (res.code == 200) {
          commit('SET_PROJECT_BTS_error_DATA', res.result)
          if (typeof (cb) === 'function') {
            cb(res.result);
          }
        } else if (res.code == 0) {
          message.warning(res.message)
        } else {
          message.error(res.message)
        }

      }).catch((error) => {
        commit('SET_LOADING', false)
        message.error("无法连接拓扑图接口")
      });
    },

    getStationLogData: ({
        commit,
        state
      }, cb) => {
      // 获取站址下所有的 平面图 信息
      axios.post('/deviceMonitor/deviceGateway/drawingLayout', {
        layoutId: state.stationId
      }).then(res => {
        commit('SET_LOADING', false)
        if (res.code == 1) {
          commit('SET_PROJECT_BTS_LOG_DATA', res)
          if (typeof (cb) === 'function') {
            cb(res);
          }
        } else if (res.code == 0) {
          message.warning(res.message)
        } else {
          message.error(res.message)
        }
      }).catch((error) => {
        commit('SET_LOADING', false)
        message.error("无法连接平面图接口")
      });
    },
    getGatewayLogData: ({
       commit,
       state
     }, cb) => {
      console.log(state.bts_id)
      // 获取网关对应的 平面图 信息
      axios.post('/deviceMonitor/deviceGateway/drawingLayout', {
        deviceGatewayId: state.bts_id
      }).then(res => {
        commit('SET_LOADING', false)
        if (res.code == 1) {
          commit('SET_PROJECT_BTS_LOG_DATA', res)
          if (typeof (cb) === 'function') {
            cb(res);
          }
        } else if (res.code == 0) {
          message.warning(res.message)
        } else {
          message.error(res.message)
        }
      }).catch((error) => {
        commit('SET_LOADING', false)
        message.error("无法连接平面图接口")
      });
    },
    getFaultLog: ({
      commit,
      state
    }, cb) => {
      data.getFaultLog(state.fault_id,
        function (data) {
          commit('SET_FAULT_SENSORS', data)
          cb(data)
        }
      )

    }
  }
}

export default tuopu